<?php
# Demo: how to start a transaction with easyproxy
# (c) Jan Groetzner, Groetzner Unternehmensberatung Seevetal
# Contact: info@easyzvt.de
# Demo for easyProxy V1.1

date_default_timezone_set("Europe/Berlin");

$cloudid="";
$license="";
$agentid="";
$devicetype="";
$devicename="";
$commandline="";
$printdata="";
$printdatalongtype="";
$printdatalong="";
$serialdata="";
$pdffile="";
$command="";

$host="https://service.easyproxy.de";
# for local testing 
# $host="http://localhost/easyproxy";

# look if this page is called by itself, get and fill in the parameters
if (isset($_REQUEST["cloudid"])) $cloudid=$_REQUEST["cloudid"];
if (isset($_REQUEST["license"])) $license=$_REQUEST["license"];
if (isset($_REQUEST["agentid"])) $agentid=$_REQUEST["agentid"];
if (isset($_REQUEST["devicetype"])) $devicetype=$_REQUEST["devicetype"];
if (isset($_REQUEST["devicename"])) $devicename=$_REQUEST["devicename"];
if (isset($_REQUEST["commandline"])) $commandline=$_REQUEST["commandline"];
if (isset($_REQUEST["printdata"])) $printdata=$_REQUEST["printdata"];
if (isset($_REQUEST["printdatalongtype"])) $printdatalongtype=$_REQUEST["printdatalongtype"]; # utf8, bin, pdf
if (isset($_REQUEST["printdatalong"])) $printdatalong=$_REQUEST["printdatalong"];
if (isset($_REQUEST["serialdata"])) $serialdata=$_REQUEST["serialdata"] ;

if (isset($_REQUEST["pdffile"])) $pdffile=$_REQUEST["pdffile"] ;

if (isset($_REQUEST["command"])) $command=$_REQUEST["command"];
if ($command=="zvt") $devicetype="ZVT";
if ($command=="prt") $devicetype="PRT";
if ($command=="lpr") $devicetype="LPR";
if ($command=="com") $devicetype="COM";

echo "<html lang=\"de\"><head><meta charset=\"utf-8\"/></head><body style=\"font-family:Arial\"><h1>easyProxy demo for zvt payment, printing and serial communication</h1>\n";
echo "<form>\n";
echo "Cloud-ID: <input name=\"cloudid\" value=\"$cloudid\" size=\"50\" /><br>\n";
echo "License: <input name=\"license\" value=\"$license\" size=\"50\" /><br>\n";
echo "Agent-ID: <input name=\"agentid\"value=\"$agentid\"  size=\"50\" /><br>\n";

echo "Directory functions: <button type=\"submit\" target=\"_this\" method=\"GET\" name=\"command\" value=\"getAgents\">getAgents</button>\n"; 
echo "<button type=\"submit\" target=\"_this\" method=\"GET\" name=\"command\" value=\"getDevices\">getDevices</button><br>\n";

echo "Devicetype: <input name=\"devicetype\" value=\"$devicetype\"  size=\"10\" /> e.g. ZVT<br>\n";
echo "Devicename: <input name=\"devicename\" value=\"$devicename\"  size=\"10\" /> e.g. 0001<br>\n";
echo "ZVT-Commandline: <input name=\"commandline\" value=\"$commandline\" size=\"30\"/> e.g. Funktion=1 or Funktion=0 Betrag=1<br>\n";

echo "ZVT-functions: <button type=\"submit\" target=\"_this\" method=\"GET\" name=\"command\" value=\"zvt\">ZVT command</button>\n";

echo "<br>printdata: (max 10 kB, json/utf8) e.g. Hello World<br><textarea name=\"printdata\" rows=\"5\" cols=\"80\">".htmlentities($printdata)."</textarea><br>\n";
echo "<br>printdatalongtype: (utf8, bin, pdf): <input name=\"printdatalongtype\" value=\"$printdatalongtype\" />\n";
echo "<br>printdatalong: (max 1MB, binary-safe with POST but little slower due to extra filetransfer)<br><textarea name=\"printdatalong\" rows=\"5\" cols=\"80\">".htmlentities($printdatalong)."</textarea><br>\n";
echo "<br>sample for pdf-upload: pdf-filename: <input name=\"pdffile\" value=\"".htmlentities($pdffile)."\" /><br>\n";


echo "PRT-functions: <button type=\"submit\" target=\"_this\" method=\"GET\" name=\"command\" value=\"prt\">Print to PRT</button>\n";
echo "LPR-functions: <button type=\"submit\" target=\"_this\" method=\"GET\" name=\"command\" value=\"lpr\">Print to LPR</button>\n";

echo "<br>serial data: e.g. 1 Cup coffee € 1,50<br><textarea name=\"serialdata\" rows=\"1\" cols=\"80\">$serialdata</textarea><br>\n";
echo "COM-functions: <button type=\"submit\" target=\"_this\" method=\"GET\" name=\"command\" value=\"com\">send serial</button>\n";

echo "</form>";

ob_flush();
flush();

# if this page was called with a command, then lets start executing the command, else just wait for data filled in the form
if (isset($_REQUEST["command"])) {
	# Generate deviceparameters as JSON
	# for a ZVT-Device create a commandline
	$deviceparams="";
	if ($command == "zvt")
	{
		$deviceparams=json_encode(array(
			"commandline"		=> $commandline
		));
	}
	# for a printer deviceparams contains printdata (short)
	elseif ($command == "prt" or $command == "lpr") {
		$deviceparams=json_encode(array("printdata" => $printdata));

		# sample upload pdffile as printdatalong
		if ($printdatalongtype=="pdf" and strlen($pdffile) > 1)
		{
			# make path php-compatible
			$pdffile = str_replace("\\","/",$pdffile);
			$pdffile = str_replace("\"","",$pdffile);

			$printdatalong=file_get_contents($pdffile);
			if (strlen($printdatalong)==0)
				die(json_encode(array("DataType"=>"Exception","Message"=>"pdffile is empty")));
		}

	}
	#for a serial cash-register-display deviceparams contains serialdata
	elseif ($command == "com") {
		$deviceparams=json_encode(array("serialdata" => $serialdata));
	}

	#Generate POST-Parameters to send to request.php (printdatalong is a separate POST-Parameter to be binary-safe
	$data = array(
		"cloudid" 			=> $cloudid, 
		"license"			=> $license,
		"agentid"			=> $agentid,
		"devicetype"		=> $devicetype,
		"devicename"		=> $devicename,
		"deviceparams"		=> $deviceparams,
		"printdatalongtype" => $printdatalongtype, #optional
		"printdatalong"		=> $printdatalong #optional
	);

	$url = $host."/apiV1/request.php";

	if ($_REQUEST["command"]=="getAgents")
		$url = $host."/apiV1/getAgents.php";
	if ($_REQUEST["command"]=="getDevices")
		$url = $host."/apiV1/getDevices.php";

	list($usec, $sec) = explode(' ', microtime());
	$time=date('d.m.Y H:i:s', $sec).substr($usec,1,4);
	echo "send request: $time <br>";
	ob_flush();
	flush();

	#prepare the request via CURL
	$curl = curl_init($url);

	curl_setopt_array($curl, 
		array(
		CURLOPT_RETURNTRANSFER => 1,
		CURLOPT_SSL_VERIFYPEER => 1,
		CURLOPT_CUSTOMREQUEST => "POST",
		CURLOPT_POSTFIELDS => http_build_query($data),
		CURLOPT_HTTPHEADER => array("Content-Type: application/x-www-form-urlencoded"),
		CURLOPT_TIMEOUT => 5 
		)
	);

	#SEND THE REQUEST
	$result = curl_exec($curl);

	list($usec, $sec) = explode(' ', microtime());
	$time=date('d.m.Y H:i:s', $sec).substr($usec,1,4);
	echo "result received: $time <br>";

	# if there something really wrong, analyze it here
	try {
		if ($result === FALSE) 
			{ echo "error"; /* Handle error */ }
		echo "Raw-result: <pre>$result</pre><br>";
		$resultjson=json_decode($result);
	}
	catch (Exception $e)
	{
		echo "Exception: " . $e->getMessage();
	}
	ob_flush();
	flush();
	
	# we got a response
	# getAgents deliveres directly a result, no further waiting required
	if ($_REQUEST["command"]=="getAgents" ) {
		echo "object-result: <pre>".print_r($resultjson,true)."</pre>";
		die();
	}

	# getDevices deliveres directly a result, no further waiting required
	if ($_REQUEST["command"]=="getDevices" ) {
		echo "object-result: <pre>".print_r($resultjson,true)."</pre>";

		if ($resultjson->DataType=="Exception") {
			die("Exception: ".$resultjson->Message);
		}
		else {
			$resultparams=$resultjson->Result;
			# count the used licenses
			$licTotalZVT=0;
			$licTotalPRT=0;
			$licTotalLPR=0;
			$licTotalCOM=0;
			$Agents=$resultparams->Agents;
			foreach ($Agents as $Agent)  {
				echo $Agent->DataType."<br>";
				if ($Agent->DataType=="ServiceInfo") {
					$ServiceInfo=$Agent->ServiceInfo;
					echo "<br>counting AgentID: " . $ServiceInfo->AgentID." AgentName: " . $ServiceInfo->AgentName . "<br>";

					$licZVT=0;
					$licPRT=0;
					$licLPR=0;
					$licCOM=0;
					foreach ($ServiceInfo->DeviceList as $Device) {
						if ($Device->DeviceType=="ZVT") $licZVT += 1;
						if ($Device->DeviceType=="PRT") $licPRT += 1;
						if ($Device->DeviceType=="LPR") $licLPR += 1;
						if ($Device->DeviceType=="COM") $licCOM += 1;
					}
					echo "device count for agent $ServiceInfo->AgentID: ZVT: $licZVT PRT: $licPRT LPR: $licLPR COM: $licCOM <br>";
					$licTotalZVT += $licZVT;
					$licTotalPRT += $licPRT;
					$licTotalLPR += $licLPR;
					$licTotalCOM += $licCOM;
				}
			}
			echo "<br>total licenses needed for cloudid $cloudid: ZVT: $licTotalZVT PRT: $licTotalPRT LPR: $licTotalLPR COM: $licTotalCOM <br>";
			die();
		}
	}

	# request.php deliveres the request-id for continous waiting of the response
	# so first get this id ...
	echo "object-result: <pre>".print_r($resultjson,true)."</pre>";

	if ($resultjson->DataType=="Exception") 
	{
		die("Exception: ".$resultjson->Message);
	}
	else 
	{
		$resultparams=$resultjson->Result;


		# get the request identifier
		$requestid=$resultparams->id;
		$requestresult=$resultparams->result;
		$requesttext=$resultparams->result_text;
	
		if ($requestresult!="OK")
			die($requestresult." ".$requesttext);
		# and now wait for the response
		$NoResultCounter=0;
		do {
			echo "wait for response<br>";
			ob_flush();
			flush();
			$data = array(
				"cloudid" 		=> $cloudid, 
				"agentid"		=> $agentid,
				"id"			=> $requestid
			);

			$url = $host."/apiV1/response.php";
			$curl = curl_init($url);

			curl_setopt_array($curl, 
				array(
				CURLOPT_RETURNTRANSFER => 1,
				CURLOPT_SSL_VERIFYPEER => 1,
				CURLOPT_CUSTOMREQUEST => "POST",
				CURLOPT_POSTFIELDS => http_build_query($data),
				CURLOPT_HTTPHEADER => array("Content-Type: application/x-www-form-urlencoded"),
				CURLOPT_TIMEOUT => 60
				)
			);
			$result = curl_exec($curl);

			if ($result === FALSE) { echo "error"; /* Handle error */ }
			echo "Result received raw<pre>$result</pre><br>";
			$resultjson=json_decode($result);
			echo "DataType: ".$resultjson->DataType." NoResultCounter: ".$NoResultCounter." ...: ";
			#hey, we got an intermediate result, show it on the cash register
			if ($resultjson->DataType=="IntermediateStatus") {
				echo $resultjson->RequestResult->DeviceResultText."<br>";
				$NoResultCounter=0; #intermediate result resets the counter, the terminal is still alive
			}
			ob_flush();
			flush();
			$NoResultCounter++;
		}	
		while ($resultjson->DataType != "FinalResult" and $NoResultCounter<6); # NoResultCounter < 6 -> maximum 3 Minutes
		#hope we got a final result, lets handle it 
		echo "<pre>".print_r($resultjson,true)."</pre>";
		if ($resultjson->DataType=="FinalResult") 
		{
			$finalresult=$resultjson->RequestResult;
			echo "Final Result: " . $finalresult->DeviceResultNum ." " . $finalresult->DeviceResultText . "<br>";
			if ($finalresult->DeviceResultNum == 0) 
				# TRANSACTION SUCCESSFUL
				echo "Transaction successful. Print and finalize your receipt<br>";
			else 
				# TRANSACTION FAILED
				echo "Transaction not successful. Errorcode is ".$finalresult->DeviceResultNum." Please try again<br>";
		}
		else 
			echo "Error: Transaction timed out...<br>"; 
		

	
		list($usec, $sec) = explode(' ', microtime());
		$time=date('d.m.Y H:i:s', $sec).substr($usec,1,4);
		echo "finished: $time <br>";

	}
}
echo "</body></html>";

?>